/***********************************************************************/
/*                                                                     */
/*  FILE        :Controller.c                                          */
/*  DATE        :Thu, Aug 20, 2015                                     */
/*  DESCRIPTION :main program file.                                    */
/*  CPU GROUP   :1B                                                    */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.19).    */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/***********************************************************************/

#include "sfr_r81b.h"
//#include <stdint.h> // no such file
#include "Controller.h"
#include "YSwitchProc.h"

// Grobal variables
volatile uint8_t g_digit[8]; // 0: left, 7: right / bcd
volatile uint8_t g_curDigit, g_blinkState;

volatile uint8_t g_swState, g_encState;

// Interrupts
// timer X			(software int 22)
#pragma interrupt	_timer_x(vect=22)
void _timer_x(void);

// Timer X (1khz)
void _timer_x(void)
{
	static uint16_t cnt;
	static uint8_t digitCnt;
	static uint16_t cnt2; // count after switch has changed
	static uint16_t cnt3; // blink

	// LED output
	digitCnt = (digitCnt+1) % 8;
	if((digitCnt == g_curDigit) && (cnt3 > 100) && g_blinkState){
		p1 = (p1 & 0b00010000) | (digitCnt << 5) | 0x0F;
	}else{
		p1 = (p1 & 0b00010000) | (digitCnt << 5) | (g_digit[digitCnt]);
	}
	
	if(cnt++ == 100){ // 100ms
		GetSwitchState(p3, (uint8_t*)&g_swState);
		cnt = 0;
	}
	if((cnt % 4) == 0){ // 2ms
		GetREncState(p3, (uint8_t*)&g_encState);
	}
	
	if((g_blinkState == 1) && (cnt2 > 1000*6)){ // 6sec
		g_blinkState = 0;
	}
	if(g_encState || g_swState) {
		cnt2 = 0;
	}else {
		cnt2 ++;
	}
	
	if(cnt3++ == 200){
		cnt3 = 0;
	}
	
	/*
	// debug
	if(cnt++ == 500){
		cnt = 0;
		p1_7 = ~p1_7;
	}*/

}

void UART0TransmitByte(uint8_t d)
{
//	uint16_t i;
	
//	while((u0c0 & 0x08) == 0);
	while((u0c1 & 0x02) == 0);
	
	u0tb = d;
}
static void SendDDSFreq()
{
	uint32_t value, freq;
	uint8_t i;
	uint8_t hsMode = 0;
	
	freq = 0;
	for(i=0; i<8; i++){
		freq *= 10;
		freq += g_digit[i];
	}
	

	// (over 520 kHz) -> HS Mode
	if(freq > 520000){
		hsMode = 1;
	}
	
	if(hsMode){
	// calculate delta value (fclk = 25 MHz / ck(cyc) = 8)
		value = (uint32_t)(5.36870869 * freq + 0.4);
	}else{
	// calculate delta value (fclk = 25 MHz / ck(cyc) = 9)
//		value = (uint32_t)(65536UL * freq / 10851UL);
//		value = (uint32_t)(65536.0 * 256.0 * freq / 2777778.0 + 0.4);
		value = (uint32_t)(6.03979728 * freq + 0.4);
	}
	
	UART0TransmitByte(0xFF);
	
	for(i=0; i<6; i++){
		UART0TransmitByte(value & 0x0F); // send 6 bytes in LSB first
		value = value >> 4;
	}
	
	if(hsMode){
		UART0TransmitByte(0xF1); // HS Mode
	}else{
		UART0TransmitByte(0xF0); // Normal Mode
	}
	
}

static void IncDigit(uint8_t digit)
{
	if(g_digit[digit] == 9){
		g_digit[digit] = 0;
		if(digit != 0) IncDigit(digit-1);
	}else{
		g_digit[digit] = (g_digit[digit]+1) & 0x0F;
	}
}
static void DecDigit(uint8_t digit)
{
	if(g_digit[digit] == 0){
		uint8_t checkUpperZero = 0;
		uint8_t i;
		for(i=0; i<digit; i++) if(g_digit[i]) checkUpperZero = 1;
		if(digit != 0 && checkUpperZero) {
			g_digit[digit] = 9;
			DecDigit(digit-1);
		}
	}else{
		g_digit[digit] = (g_digit[digit]-1) & 0x0F;
	}
}

static void ChangeClock(){
	prc0 = 1;
	hra00 = 1;
	cm06 = 0;
	hra2 = 0;// 8mhz
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	hra01 = 1;
	ocd2 = 1;
	prc0 = 0;
}

void Init(){
	uint8_t i;
	ChangeClock();
	
	// init vars.
	for(i=0; i<8; i++){
		g_digit[i] = 0;
	}
	
	// init port
	pd1 = 0b11111111; // port direcion
	pd3 = 0b00000000;
	pd4 = 0b00000000;
	
	p1  = 0b00000000; // port state
	p3  = 0b00000000;
	p4  = 0b00000000;
	pu06 = 1; // P3_3 pull-up
	pu07 = 1; // P3_4,5,7 pull-up

	// init timer (1/8000 = 1khz)
	
	// timer x
	prex = 80;  // prescaler
	tx   = 100; // timer
	txmr = 0b00001000;// timer mode
	tcss = 0b00000000;// fsrc = f1
	ilvl0_txic = 7; // timer x interrupt level 7
	
	// init adc
//	adcon0 = 0b10010100; // AN8, select f2
//	adcon1 = 0b00101000; // 10bit mode
//	adcon2 = 0b00000001; // enable s&h

	// init uart
	u0brg = 25; // bit rate
	u0mr  = 0b00010101;
	u0c0  = 0b00000000; // select f1
	u0c1  = 0b00000001; // enable tx
	ucon  = 0b00000000;
	
	
	// init bod
	vca2 = 0b01000000;
	vw1c = 0b01000001;
	
	g_curDigit = 7;
	
	// enable interrupt
	asm("FSET I");
}


void main(void);

void main(void)
{
	unsigned int i;
	Init();
	
	
	while(1){
		// check switch
		if(g_swState){
			if(g_blinkState){
				uint8_t state = g_swState;
				if(state == SW_SW1){
					g_curDigit = (g_curDigit-1)%8;
				}else if(state == SW_SW2){
					g_curDigit = (g_curDigit+1)%8;
				}
			}
			g_swState = 0;
			g_blinkState = 1;
		}
		if(g_encState){
			if(g_blinkState){
				uint8_t state = g_encState;
				if(state == RENC_FWD){
					IncDigit(g_curDigit);
				}else if(state == RENC_REV){
					DecDigit(g_curDigit);
				}
			}
			g_encState = 0;
			SendDDSFreq();
			
			g_blinkState = 1;
			
			
		}
	}
}
